list.linkedlist

## Class BaseLinkedList

- java.lang.Object
- - list.listinterface.BaseList
  - - list.linkedlist.BaseLinkedList

- All Implemented Interfaces:
    BaseListInterface, CommonBase
  Direct Known Subclasses:
    QueueLinkedList, StackLinkedList

      class BaseLinkedList
      extends BaseList
      implements BaseListInterface

  Společný základ pro implememtaci spojových seznamů.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected LinkedListMember` | `first` odkaz na první člen (hlavu) seznamu
    `private int` | `size` kapacita seznamu

    - ### Fields inherited from class list.listinterface.BaseList

      `moveCounter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BaseLinkedList(int aSize)` Vyrobí seznam.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Element` | `getElement()` Vrátí hodnotu běžného prvku.
    `int` | `getSize()` Zjistí kapacitu seznamu.
    `protected boolean` | `isEmpty()` Zjistí, zda je seznam prázdný.
    `void` | `moveFirst()` Učiní hlavu seznamu běžným prvkem.
    `Element` | `remove()` Odstraní běžný prvek.
    `void` | `setElement(Element value)` Nastaví hodnotu běžného prvku do členu datové struktury.

    - ### Methods inherited from class list.listinterface.BaseList

      `getMoveCounter, resetMoveCounter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface list.listinterface.CommonBase

      `getMoveCounter, resetMoveCounter`

- - ### Field Detail

    - #### size

          private int size

      kapacita seznamu

    - #### first

          protected LinkedListMember first

      odkaz na první člen (hlavu) seznamu

  - ### Constructor Detail

    - #### BaseLinkedList

          public BaseLinkedList(int aSize)

      Vyrobí seznam.
      Parameters:
        `aSize` - kapacita seznamu

  - ### Method Detail

    - #### isEmpty

          protected boolean isEmpty()

      Zjistí, zda je seznam prázdný.
      Returns:
        true když je prázdný, jinak false

    - #### setElement

          public void setElement(Element value)

      Description copied from interface: `CommonBase`
      Nastaví hodnotu běžného prvku do členu datové struktury.

      Vyžaduje: not isEmpty

      Specified by:
        `setElement` in interface `CommonBase`
      Specified by:
        `setElement` in class `BaseList`
      Parameters:
        `value` - prvek, který má být uložen do členu

    - #### getElement

          public Element getElement()

      Description copied from interface: `CommonBase`
      Vrátí hodnotu běžného prvku.

      Vyžaduje: not isEmpty

      Specified by:
        `getElement` in interface `CommonBase`
      Specified by:
        `getElement` in class `BaseList`
      Returns:
        hodnota běžného prvku

    - #### remove

          public Element remove()

      Odstraní běžný prvek.

      Popis: vyjme prvek z hlavy seznamu.

      Užití: typ výsledku se řídí specializací typu Element.

      Vyžaduje: not isEmpty

      Splní: not IsFull

      Specified by:
        `remove` in interface `BaseListInterface`
      Specified by:
        `remove` in class `BaseList`
      Returns:
        prvek, který byl hlavou seznamu

    - #### moveFirst

          public void moveFirst()

      Description copied from interface: `BaseListInterface`
      Učiní hlavu seznamu běžným prvkem.

      Vyžaduje: not isEmpty

      Specified by:
        `moveFirst` in interface `BaseListInterface`
      Specified by:
        `moveFirst` in class `BaseList`

    - #### getSize

          public int getSize()

      Description copied from interface: `BaseListInterface`
      Zjistí kapacitu seznamu. To jest max. možný počet prvků, které smějí být v seznamu.
      Specified by:
        `getSize` in interface `BaseListInterface`
      Specified by:
        `getSize` in class `BaseList`
      Returns:
        kapacita seznamu